discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

from . import views

app_name = 'todolist'

urlpatterns = [
    # The path() function receives four arguments
    # We will focus on 2 arguments that are required: 'route' and 'view'
    path('', views.index, name="index"),

    # todolist/1
    # The <int:todoitem_id>/ allows for creating a dynamic link where the todoitem_id is provided
    path('task/<int:todoitem_id>/', views.todoitem, name="todoitem"),
    path('event/<int:event_id>/', views.view_event, name="view_event"),

    path('register', views.register, name="register"),
    path('change_password', views.change_password, name="change_password"),
    path('login', views.login_view, name="login"),
    path('logout', views.logout_view, name="logout"),
    path('add_task', views.add_task, name="add_task"),
    path('create_event', views.create_event, name="create_event"),

]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
    task_name = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default = "pending")
    date_created = models.DateTimeField('date created')
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")
    
class Event(models.Model):
    event_name = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default = "pending")
    event_date = models.DateTimeField('event date')
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class RegisterForm(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    first_name = forms.CharField(label="First Name", max_length=25)
    last_name = forms.CharField(label="Last Name", max_length=25)
    email = forms.CharField(label="Email", max_length=50)
    password = forms.CharField(label="Password", max_length=25)
    is_staff = False
    is_active = True
    

class LoginForm(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
    task_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)

class CreateEventForm(forms.Form):
    event_name = forms.CharField(label="Event Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    event_date = forms.DateField(label="Select a date", input_formats=['%Y-%m-%d'])

todolist/views.py
from django.shortcuts import render

# Create your views here.
from django.http import HttpResponse

from .models import ToDoItem, Event
from .forms import LoginForm, AddTaskForm, RegisterForm, CreateEventForm

from django.contrib.auth.models import User
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.hashers import make_password
from django.forms.models import model_to_dict
from django.utils import timezone

def index(request):
    todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
    event_list = Event.objects.filter(user_id = request.user.id)

    context = {
        'todoitem_list' : todoitem_list,
        'event_list' : event_list,
        "user" : request.user
    }
    # context = {'todoitem_list' : todoitem_list}

    return render(request, "todolist/index.html", context)

    # return HttpResponse("Hello from the views.py file")

def todoitem(request, todoitem_id):

    # todoitem = model_to_dict(ToDoItem.objects.get(pk=todoitem_id))
    todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
    # response = "You are viewing the details of %s"
    # return HttpResponse(response %todoitem_id)
    return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def register(request):
    # users = User.objects.all()
    # is_user_registered = False
    # context = {
    #     "is_user_registered": is_user_registered
    # }

    # check if the username "johndoe" already exists
    # if it exists, change the value of variable is_user_registered to True
    # for indiv_user in users:
    #     if indiv_user.username == "johndoe":
    #         is_user_registered = True
    #         break

    # if is_user_registered == False:
    #     user = User()
    #     user.username = "johndoe"
    #     user.first_name = "John"
    #     user.last_name = "Doe"
    #     user.email = "john@mail.com"
    #     # The set_password is used to ensure that the password is hashed using Django's authentication framework
    #     user.set_password("john1234")
    #     user.is_staff = False
    #     user.is_active = True
    #     user.save()

    #     context = {
    #         "first_name": user.first_name,
    #         "last_name": user.last_name
    #     }

    # return render(request, "todolist/register.html", context)

    context = {}

    if request.method == "POST":
        form = RegisterForm(request.POST)
        if form.is_valid() == False:
            form = RegisterForm()
        else:
            username = form.cleaned_data['username']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']
            # password = make_password(form.cleaned_data['password'], salt=10, hasher='default')
            password = make_password(form.cleaned_data['password'])
            duplicate = User.objects.filter(username = username)
            duplicate = User.objects.filter(email = email)

            if not duplicate:
                User.objects.create(username = username, first_name = first_name, last_name = last_name, email = email, password = password)
                return redirect("todolist:login")
            else:
                context = {
                    "error" : True
                }

    return render(request, "todolist/register.html", context)
        
def change_password(request):
    is_user_authenticated = False

    user = authenticate(username="johndoe", password="johndoe1")
    print(user)

    if user is not None:
        authenticated_user = User.objects.get(username='johndoe') # this is where we get the user with username 'johndoe'
        authenticated_user.set_password("johndoe2") # this is where we change the password
        authenticated_user.save()
        is_user_authenticated = True
    context = {
        "is_user_authenticated": is_user_authenticated
    }

    return render(request, "todolist/change_password.html", context)

def login_view(request):

    context = {}

    if request.method == "POST":
        # Create a form instance and populate it with data from the request
        form = LoginForm(request.POST)
        # Check whether the data is valid
        # Runs validation routines for all the form fields and returns true and places the form's data in the cleaned_data attribute
        if form.is_valid() == False:
            # Return a blank login form
            form = LoginForm()
        else:
            # Receives the information from the form
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username = username, password = password)
            context = {
                "username" : username,
                "password" : password
            }
            if user is not None:
                login(request, user)
                return redirect("todolist:index")
            else:
                context = {
                    "error" : True
                }

    return render(request, "todolist/login.html", context)


    # username = "johndoe"
    # password = "johndoe2"
    # user = authenticate(username = username, password = password)
    # context = {
    #     "is_user_authenticated" : False
    # }
    # print(user)
    # if user is not None:
    #     login(request, user)
    #     return redirect("todolist:index")
    # else:
    #     return render(request, "todolist/login.html", context)

def logout_view(request):
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}

    if request.method == "POST":
        form = AddTaskForm(request.POST)
        if form.is_valid() == False:
            form = AddTaskForm()
        else: 
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            duplicate = ToDoItem.objects.filter(task_name =  task_name)

            if not duplicate:
                ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id = request.user.id)
                return redirect("todolist:index")

            else: 

                context = {
                    "error" : True
                }

    return render(request, "todolist/add_task.html", context)

def create_event(request):
    context = {}

    if request.method == "POST":
        form = CreateEventForm(request.POST)
        if form.is_valid() == False:
            form = CreateEventForm()
        else: 
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            event_date = form.cleaned_data['event_date']
            duplicate = Event.objects.filter(event_name = event_name)

            if not duplicate:
                Event.objects.create(event_name=event_name, description=description, event_date=event_date, user_id = request.user.id)
                return redirect("todolist:index")

            else: 

                context = {
                    "error" : True
                }

    return render(request, "todolist/create_event.html", context)

def view_event(request, event_id):

    # todoitem = model_to_dict(ToDoItem.objects.get(pk=todoitem_id))
    event = get_object_or_404(Event, pk=event_id)
    # response = "You are viewing the details of %s"
    # return HttpResponse(response %todoitem_id)
    return render(request, "todolist/view_event.html", model_to_dict(event))

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Add A Task</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate task found</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Task Name: </label>
					    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/change_password.html
{% if is_user_authenticated == False %}
    <h1>Invalid User Credentials</h1>
    <p>Check if the username and password is correct</p>
{% else %}
    <h1>User Password Successfully Updated</h1>
    <p>The password has been successfully updated</p>
{% endif %}

todolist/templates/todolist/create_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Create Event</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate event found</p>
				{% endif %}
				<form action="{% url 'todolist:create_event' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="event_name">Event Name: </label>
					    <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="mb-3">
					    <label for="event_date">Select a Date: </label>
					    <input class="form-control" type="date" name="event_date" value="{{ event_date }}" required>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Event">
					</div>

				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

<!-- Provides the title of the page to be provided in the template -->
<!-- This should correspond with the block name provided in the base.html -->
{% block title %} Home {% endblock %}

{% block content %}

    {% if todoitem_list and user.is_anonymous == False %}
        <h1 class="text-center my-3">Welcome {{ user.first_name }} {{user.last_name}}!</h1>

        <div class="container">

            <div class="row">

                <h3 class="text-center mb-3">My Tasks</h3>

                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                {% for todoitem in todoitem_list %}
                    <li><a href="{% url 'todolist:todoitem' todoitem.id %}">{{ todoitem.task_name }}</a></li>
                {% endfor %}
                </ul>

            </div>

            {% if event_list %}

                <div class="row">

                    <h3 class="text-center mb-3">My Events</h3>

                    <ul class="list-group col-lg-2 offset-lg-5 text-center">
                    {% for event in event_list %}
                        <li><a href="{% url 'todolist:view_event' event.id %}">{{ event.event_name }}</a></li>
                    {% endfor %}
                    </ul>

                </div>

            {% else %}

                <p>No events have been created.</p>

            {% endif %}
            
        </div>
        
    {% elif user.is_anonymous == True %}

        <h1 class="text-center my-3">You are not authorized to access this page.</h1>
        <p>Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
        
    {% else %}

        <p>No tasks have been created.</p>

    {% endif %}

{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html' %}

	{% block title %}Login{% endblock %}

	{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Login</h1>
				{% if error == True %}
					<p class="text-danger">Invalid user credentials, please check your username and password</p>
				{% endif %}
				<form action="{% url 'todolist:login' %}" method="post">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Login">
					</div>

				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/register.html
{% extends 'base.html' %}

	{% block title %}Register{% endblock %}

	{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Register</h1>
				{% if error == True %}
					<p class="text-danger">Username or email already exists</p>
				{% endif %}
				<form action="{% url 'todolist:register' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="first_name">First Name: </label>
					    <input class="form-control" id="first_name" type="text" name="first_name" value="{{ first_name }}" maxlength="25" required>
					</div>

					<div class="mb-3">
					    <label for="last_name">Last Name: </label>
					    <input class="form-control" id="last_name" type="text" name="last_name" value="{{ last_name }}" maxlength="25" required>
					</div>

					<div class="mb-3">
					    <label for="email">Email: </label>
					    <input class="form-control" id="email" type="email" name="email" value="{{ email }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="password">Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="confirm_password">Confirm Password: </label>
					    <input class="form-control" id="confirm_password" type="password" name="confirm_password" value="{{ confirm_password }}" maxlength="20" required>
					</div>

                    {% if password == confirm_password %}
                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Register">
                        </div>
                    {% else %}
                        <div class="text-center">
                            <input class="btn btn-danger" type="submit" value="Register" disabled>
                        </div>
                    {% endif %}

				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/todoitem.html
<h1>{{ task_name }}</h1>
<h3>Description</h3>
<p>{{ description }}</p>
<h3>Status</h3>
<p>{{ status }}</p>
<a href="{% url 'todolist:index' %}">Back to index page</a>

todolist/templates/todolist/view_event.html
<h1>{{ event_name }}</h1>
<h3>Description</h3>
<p>{{ description }}</p>
<h3>Status</h3>
<p>{{ status }}</p>
<a href="{% url 'todolist:index' %}">Back to index page</a>